/*
 *  $Id: alltoall.c,v 1.5 1993/11/24 00:49:13 doss Exp $
 *
 *  (C) 1993 by Argonne National Laboratory and Mississipi State University.
 *      All rights reserved.  See COPYRIGHT in top-level directory.
 */

#ifndef lint
static char vcid[] = "$Id: alltoall.c,v 1.5 1993/11/24 00:49:13 doss Exp $";
#endif /* lint */

#include <mpi.h>
#include "coll.h"

/*@

MPI_Alltoall - 

@*/
int MPI_Alltoall(sendbuf,sendcnt,sendtype,recvbuf,recvcnt,recvtype,comm)
void             *sendbuf;
int               sendcnt;
MPI_Datatype      sendtype;
void             *recvbuf;
int               recvcnt;
MPI_Datatype      recvtype;
MPI_Comm          comm;
{
  int        size, rank, i, extent;
  int        errno = MPI_SUCCESS;
  MPI_Status status;
  
  /* Check for invalid arguments */
  if ( (comm            == (MPI_Comm)0) ||
       (comm->comm_type == MPIR_INTER) ) 
    return (errno); 
  
  /* Get size and rank and switch to collective communicator */
  MPI_Comm_size ( comm, &size );
  MPI_Comm_rank ( comm, &rank );
  comm = comm->comm_coll;

  /* Send to all - receive from all */
  MPI_Type_extent ( recvtype, &extent );
  for ( i=0; i<size; i++ ) { 
       MPI_Sendrecv( (void *)((int)sendbuf+i*sendcnt*extent), sendcnt, sendtype, i,
                     (void *)((int)recvbuf+i*recvcnt*extent), recvcnt, recvtype, i, 
		     MPIR_ALLTOALL_TAG, comm, &status );
  }

  return (errno);
}
