/*
 *  $Id: comm_free.c,v 1.6 1993/11/12 12:31:42 doss Exp $
 *
 *  (C) 1993 by Argonne National Laboratory and Mississipi State University.
 *      All rights reserved.  See COPYRIGHT in top-level directory.
 */

/*@

MPI_Comm_free - marks the communicator object for deallocation

@*/

#include <mpi.h>


int MPI_Comm_free ( comm )
MPI_Comm *comm;
{
  if ( (comm != (MPI_Comm *)0) && ((*comm) != (MPI_Comm)0) ) {
    
    /* Free the contexts used by this communicator */
    (void) MPIR_Context_dealloc ( (*comm), 2, (*comm)->send_context );

    /* Free cache information */
    MPIR_Attr_free_tree ( *comm );

    /* Free collective communicator and group */
    MPI_Group_free ( &((*comm)->group) );
    FREE( (*comm)->comm_coll );

    /* Free comm structure and set comm to null */
    FREE( *comm );
    (*comm) = NULL;
  }
  return (MPI_SUCCESS);
}
